<?php

function forum_stats_page() {
  $comments_stats = db_query("SELECT FROM_UNIXTIME(created, '%Y-%m-%d') as date, COUNT(*) as count
    FROM {comment}
    WHERE created > :date
    GROUP BY date
    ORDER BY date DESC", array(':date' => strtotime('1 month ago')))
  ->fetchAllKeyed();

  $topics_stats = db_query("SELECT FROM_UNIXTIME(created, '%Y-%m-%d') as date, COUNT(*) as count
    FROM {node}
    WHERE created > :date AND type = 'forum'
    GROUP BY date
    ORDER BY date DESC", array(':date' => strtotime('1 month ago')))
    ->fetchAllKeyed();

  $days = _forum_stats_date_range('1 month ago', 'now');

  return theme('forum_stats_chart', array(
    'days' => $days,
    'topics' => array_map(function($day) use ($topics_stats) {
      return $topics_stats[$day] ? (int)$topics_stats[$day] : 0;
    }, $days),
    'comments' => array_map(function($day) use ($comments_stats) {
      return $comments_stats[$day] ? (int)$comments_stats[$day] : 0;
    }, $days),
  ));
}

function _forum_stats_date_range($first, $last, $step = '+1 day', $format = 'Y-m-d') {
  $dates = array();
  $current = strtotime($first);
  $last = strtotime($last);

  while ($current <= $last) {
    $dates[] = date($format, $current);
    $current = strtotime( $step, $current );
  }

  return $dates;
}
